#ifndef ALARMTIME_H
#define ALARMTIME_H
#include <QTime>
#include <QObject>
#include <QRunnable>
#include <QScopedPointer>
#include <QEventLoop>
#include <QTimer>
#include <QProcess>
#include <QDebug>

class AlarmTime : public QObject, public QRunnable
{
    Q_OBJECT
private:

    bool triggerd_ = false;
    QTime time_;
    QTimer timer;
    QScopedPointer<QEventLoop> loop;

public:
    explicit AlarmTime(const QTime time = QTime::currentTime(), QObject *parent = 0);
    ~AlarmTime();

signals:
    void trigger();

public slots:
    void run();
    void abort();
    void runOrAbort(int state);
    void doTick();
    void changeTime(QTime time);
};

#endif // ALARMTIME_H
